// gameinvader4d.cpp: implementation of the generic cGameInvader4D class.
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "gameinvader4d.h"
#include "critterarmed.h"
#include "listener.h"
#include "spriteicon.h"
#include "pop.h" //for playSound
#include "popview.h"
#include "force.h"
#include "spritebubble.h"
#include "graphicsopengl.h"
#include "graphicsmfc.h"
#include "critterviewer.h"
#include "spritemultiicon.h"
#include "hypercube.h"
#include "hyperhouse.h"
#include "hyperpyramid.h"
#include "hypertetrahedron.h"
#include "listener4D.h"

IMPLEMENT_SERIAL(cGameInvader4D, cGame, 0);
IMPLEMENT_SERIAL(cCritterInvader4DPlayer, cCritterArmedPlayer, 0);
IMPLEMENT_SERIAL(cCritterInvader4DRival, cCritterArmedRobot, 0);
IMPLEMENT_SERIAL(cCritterInvader4DProp, cCritter, 0);
IMPLEMENT_SERIAL(cCritterInvader4DPropFrag, cCritter, 0);
IMPLEMENT_SERIAL(cCritterInvader4DPlayerBullet, cCritterBullet, 0);
IMPLEMENT_SERIAL(cCritterInvader4DRivalBullet, cCritterBullet, 0);

//#define DEBUGINVADER  //Comment DEBUGINVADER in to start with only one critter besides player.
//#define LOOPEXPLOSION
	/*Comment in LOOPEXPLOSION to have a bitmap cSpriteLoop  for a prop that's 
	been shot.  This does slow things down a bit, not because of the loop, but because of
	the bitmap.  Comment out LOOPEXPLOSION to just show a hit by changing the sprite to
	a wireframe. */

#define PROPSEEDPERCENTOFZ 0.1 //Means use the low-z 20% of world box to seed prop critters into.
//==============================cGameInvader4D
int cGameInvader4D::PLAYERHEALTH = 10;
int cGameInvader4D::DEFAULTSEEDCOUNT = 6;
int cGameInvader4D::DEFAULTRIVALCOUNT = 0;
Real cCritterInvader4DProp::EXPLOSIONDISPLAYTIME = 0.75;
Real cCritterInvader4DPropFrag::FIXEDLIFETIME = 1.2;
int cCritterInvader4DProp::FRAGCOUNT = 5;

cGameInvader4D::cGameInvader4D() //The constructor gets called only once, at first start.
{	
	_menuflags &= ~cGame::MENU_2D; 
		//Default _menuflags from cGame has hopper off, autoplay off.  Turn off 2D.
	//_menuflags &= ~cGame::MENU_CHANGELISTENER; 
		/* The way player is set up, it's bad to use any listener other than
		the default cListenerArrowAttitude4D. */
	_menuflags &= ~cGame::MENU_BOUNCEWRAP; 
		/* If we allow wrap it gets screwy. */
	_rivalcount = cGameInvader4D::DEFAULTRIVALCOUNT; 
		//The number of cCritterRival that I plan to add.
	_seedcount = cGameInvader4D::DEFAULTSEEDCOUNT; 
		//The number of cCritterInvader4DProp that I plan to add.
#ifdef DEBUGINVADER
	_rivalcount = 0;
	_seedcount = 1;
#endif //DEBUGINVADER
	_wrapflag = cCritter::WRAP; /* Sets the critters to match when added.
//		Default wrap is cCritter::WRAP. */
	//_wrapflag = cCritter::BOUNCE;
	_spritetype = cGame::ST_HYPERCUBES;//cGame::ST_SIMPLEPOLYGONS;
	//_spritetype = cGame::ST_HYPERTETRAHEDRONS;
		 //Default sprite for cCritterInvader4DProp critters
//Fix your statics
	cCritter::MAXSPEED = 4.0; /* Speed used for _maxspeed in critter constructors. */

//Fix the border
	_border.set(40, 40, 41.0, 10.0); 
	
	//Set the background bitmap
	setBackgroundBitmap(IDB_BACKGROUND); /*  Sets the cSpriteBackground for the 
		background bitmap. Note that you must call this after the _border has its size
		fully initialized. So each	cGame child with a different border should call
		this again in its constructor. */
//Make a player
	setPlayer(new cCritterInvader4DPlayer(this));
//Set the cursor tools.
	/*_arrayHCURSOR has only the _hCursorArrow inherited from cGame. 
		 Add a Shooting cursor. */
	_arrayHCURSOR.Add(((CPopApp*)::AfxGetApp())->_hCursorPlay); 

	pplayer()->setShield(TRUE);

	polletSuggestion = FALSE;
	showPlayerPosition = FALSE;
	gameOver = FALSE;
	win = FALSE;
	previousLevel = 0;
}

#define GAMELEVEL
void cGameInvader4D::step(Real dt, CPopView *pactiveview)
{
	cGame::step(dt, pactiveview);
#ifdef GAMELEVEL
	if(_level-previousLevel == 2)//if a new level starts
	{	
		previousLevel++;
		pplayer()->setHealth(cGameInvader4D::PLAYERHEALTH); //rest players health
	}
#endif
}

void cGameInvader4D::drawForeground(cGraphics *pgraphics, int drawflags, cCritterViewer4D *pviewpointcritter4D)
{
#ifndef GAMELEVEL
	cGame::drawForeground(pgraphics, drawflags, pviewpointcritter4D);
#else
	//we give a different border color for each level
	cRealBox borderface(_border);
	borderface.pcolorstyle()->setEdged(TRUE);
	borderface.pcolorstyle()->setFilled(FALSE);
	if(_level == 1)
		borderface.pcolorstyle()->setLineColor(cColorStyle::CN_BLACK);
	if(_level == 2)
		borderface.pcolorstyle()->setLineColor(RGB(0,190,0));//dark green
	if(_level == 3)
		borderface.pcolorstyle()->setLineColor(cColorStyle::CN_PURPLE);
	if(_level == 4)
		borderface.pcolorstyle()->setLineColor(cColorStyle::CN_LIGHTBLUE);
	
	borderface.draw(pgraphics, drawflags, pviewpointcritter4D);
#endif
}

/* seedCritters makes and positions any temporary critters.  This gets
	automatically called when we select a game by the CPopDoc::setGameClass call.  It also gets
	called by cGame::reset() if you restart a game.*/
void cGameInvader4D::seedCritters()
{
	pbiota()->purgeNonPlayerNonWallCritters(); 
		/* Clean out any old non-player non-wall critters. Although we don't have 
			walls yet, you might want to put some in. */
 	for (int i=0; i < _seedcount; i++)
 		new cCritterInvader4DProp(this); 
	for (i=0; i<_rivalcount; i++)
		new cCritterInvader4DRival(this);
}

/* cGameInvader4D::reset does not get called at first startup, is called only when you start a
	 new round or 	level of the game.*/
void cGameInvader4D::reset() 
{
	_rivalcount = cGameInvader4D::DEFAULTRIVALCOUNT;
	_seedcount = cGameInvader4D::DEFAULTSEEDCOUNT;
	cGame::reset(); 	
	pplayer()->setAttitude(cMatrix::identityMatrix());
	pplayer()->moveTo(cVector(0,0,pplayer()->moveBox().hiz()));
	
#ifdef GAMELEVEL
	if(win)
		AfxMessageBox("You win!\n", MB_OK | MB_ICONINFORMATION);
	previousLevel = 0;

	if(gameOver)
	{
		this->setSpritetype(cGame::ST_HYPERCUBES);
		win = FALSE;
	}
#endif
}

/* This gets called at startup and when you begin a new game.  This is the
place to set the background or the kind of cursor you want to use. */
void cGameInvader4D::initializeView(CPopView *pview)
{
	cGame::initializeView(pview); //Always call the baseclass method.
	pview->setCursor(((CPopApp*)::AfxGetApp())->_hCursorPlay);
		 //We do want to be able to use the shoot cursor
	pview->setUseBackgroundBitmap(FALSE); //Default was TRUE
	pview->setUseSolidBackground(FALSE); //Default was TRUE
	pview->setGraphicsClass(RUNTIME_CLASS(cGraphicsOpenGL)); //This is a 3D game
	pview->pviewpointcritter()->setListener(new cListenerViewerRide());
		//Or comment this out for non-riding behavior, also good.
}

void cGameInvader4D::initializeViewpoint(cCritterViewer *pviewer)
{
	if (pviewer->plistener()->GetRuntimeClass()
		== (RUNTIME_CLASS(cListenerViewerRide)))
	{
		pviewer->zoom(0.35); //0.35 Wideangle 
		cListenerViewerRide *prider = (cListenerViewerRide*)(pviewer->plistener());
		prider->setOffset(-4.0*cVector::XAXIS); /* This offset is in the coordinate
			system of the player, where the negative X axis is the negative of the
			player's tangent direction, which means stand right behind the player. */
	}
	else //Not riding the player.
	{
		pviewer->zoom(1.0);
		/* The two args to setViewpoint are (directiontoviewer, lookatpoint).
			Note that directiontoviewer points FROM the origin TOWARDS the viewer. */
		if (pviewer->is3D())
		{
			pviewer->setViewpoint(cVector(0.0, 0.15, 1.0), _border.center());
			pviewer->roll(PI*1.5);//270
		}
		else //2D case.
			pviewer->setViewpoint(-cVector::ZAXIS, _border.center());
	}
}

CString cGameInvader4D::statusMessage()
{
	CString gameLevel;
	CString playerPosition;
	CString cStrStatusBar = cGame::statusMessage(); //Get the standard message
	
	gameLevel.Format("Level: %d",_level);
	cStrStatusBar += gameLevel;
	if(showPlayerPosition)
	{
		Real w = sqrt(pplayer()->position().x()*pplayer()->position().x()+
			pplayer()->position().y()*pplayer()->position().y()+
			pplayer()->position().z()*pplayer()->position().z());
		playerPosition.Format("Position: %0.1f %0.1f %0.1f %0.1f", pplayer()->position().x(),
		pplayer()->position().y(),
		pplayer()->position().z(),
		20.201-w);
		cStrStatusBar +=" "+playerPosition; 
	}
	return cStrStatusBar;
}

void cGameInvader4D::adjustGameParameters()
{
// (1) End the game if the player is dead
	if (!health()  && !_gameover) //Player's been killed and game's not over.
	{
		_gameover = TRUE;
		pplayer()->addScore(_scorecorrection); // So user can reach _maxscore 
		playSound("Tada");
		return; 
	}
// (2) Perhaps do this to reseed the screen if rivals and props are gone.
	int propcount = pbiota()->count(RUNTIME_CLASS(cCritterInvader4DProp));
	int rivalcount = pbiota()->count(RUNTIME_CLASS(cCritterInvader4DRival));
	if (propcount+rivalcount==0) //Player is alone with bullets and fragments
		seedCritters();
// (3) Also don't let the propcount diminish.
			//(need to recheck propcount in case we just called seedCritters).
	propcount = pbiota()->count(RUNTIME_CLASS(cCritterInvader4DProp));
	int propstoadd = _seedcount - propcount;
 	cCritterInvader4DProp * prop = NULL;
	Real increment = 50;
	for (int i=0; i < propstoadd; i++)
	{
		prop = new cCritterInvader4DProp(this);

#ifdef GAMELEVEL		
		if(score()>=0&&score()<increment) //1st level
		{
			_level = 1;
			prop->setSprite(new cSpriteHypercube());
			_spritetype = cGame::ST_HYPERCUBES;
		}
		if(score()>=increment&&score()<increment*2) //2nd level
		{	
			_level = 2;
			prop->setSprite(new cSpriteHyperhouse());
			_spritetype = cGame::ST_HYPERHOUSES;
			//prop->addForce(new cForceClassEvade( 0.2, //acceleration //
			//0.2, //dart speedup
			//RUNTIME_CLASS(cCritterBullet),
			//TRUE)); /*  TRUE means evade all child classes of cCritterBullet. */
		}
		if(score()>=increment*2&&score()<increment*3)//3rd level
		{
			_level = 3;
			prop->setSprite(new cSpriteHyperpyramid());
			_spritetype = cGame::ST_HYPERPYRAMIDS;
			//prop->addForce(new cForceClassEvade( 0.5, //acceleration //
			//0.5, //dart speedup
			//RUNTIME_CLASS(cCritterBullet),
			//TRUE)); /*  TRUE means evade all child classes of cCritterBullet. */
		}
		if(score()>=increment*3&&score()<increment*4)//4th level
		{
			_level = 4;
			prop->setSprite(new cSpriteHypertetrahedron());
			_spritetype = cGame::ST_HYPERTETRAHEDRONS;
			prop->addForce(new cForceClassEvade( 2.0, //acceleration //
			3.0, //dart speedup
			RUNTIME_CLASS(cCritterBullet),
			TRUE)); /*  TRUE means evade all child classes of cCritterBullet. */
		}
#endif
	}

#ifdef GAMELEVEL
	if(score()>=increment*4) //game over
	{
		gameOver = TRUE;
		win = TRUE;
		reset();
	}
#endif
}

void cGameInvader4D::Serialize(CArchive& ar)
{
	cGame::Serialize(ar);
	if (ar.IsStoring()) // Save any extra variables
		ar << _rivalcount ; //Line of form ar << ...
	else //Load any extra variables 
		ar >> _rivalcount; //Line of form ar >> ...
}

void cGameInvader4D::setWrapflag(int wrapflag)
{
	cGame::setWrapflag(wrapflag);
	//Player shouldn't wrap
	pplayer()->setWrapflag(cCritter::BOUNCE);
}

//====================cCritterInvader4DPlayer
cCritterInvader4DPlayer::cCritterInvader4DPlayer(cGame *pownergame):
cCritterArmedPlayer(pownergame)
{
	//Set the listener
	setListener(new cListenerArrowAttitude4D());
	//Set the bullet
 	setBulletClass(RUNTIME_CLASS(cCritterInvader4DPlayerBullet));
	//setWaitShoot(2.0*cCritterArmed::WAITSHOOT); //Don't shoot as fast as usual.
	//Set other variables, perhaps including sprite.
	setHealth(cGameInvader4D::PLAYERHEALTH);
	/* Maybe add some forces like gravity; the player will ignore them unless
		you use a car or spaceship listener, but the bullets it shoots will use them. */
	setMaxspeed(2.5*1.3*cCritterBulletSilverMissile::MAXSPEED); //So you can catch them.
	setAttitudeToMotionLock(FALSE); //don't turn your sprite with the motions.
	setAimToAttitudeLock(FALSE); //Don't turn your attitude with the gun.
	
#define FOURDVIEWER
#ifdef FOURDVIEWER
	setAttitudeTangent(-cVector::WAXIS); //point into the inner cube
	setAimVector(cVector::WAXIS);
#else
	setAttitudeTangent(-cVector::ZAXIS); //point down into the world.
	setAimVector(-cVector::ZAXIS);
#endif

	setSprite(new cSpriteCircle());
	psprite()->setFilled(FALSE); //So I can see through the center of the disk.
	psprite()->setSpriteAttitude( cMatrix::yRotation(PI/2.0)); //To face the user.
	setRadius(0.3);
	
	/* The cCritterArmedPlayer constructor call has already set the  player's _movebox
		to match the pownergame border.  Now we limit the movebox size. */
	setMoveBox(cRealBox(  //Make your move box the near layer of the world.
		_movebox.locorner() , //lo
		_movebox.hicorner() - (0.9*_movebox.wsize())*cVector::WAXIS)); //hi
	
	moveTo(cVector(0,0,_movebox.hiz()));//start at center
	
	setWrapflag(cCritter::BOUNCE); //don't wrap.
	
	setPrismDz(0.1); //This will look better than the default PLAYERPRISMDZ = 0.5.
}

void cCritterInvader4DPlayer::draw(cGraphics *pgraphics, int drawflags,cCritterViewer4D * pviewer4D)
{
	//Overlaod this so to not have the default drawHighlight call of cCritterArmedPlayer::draw
	if(((cGameInvader4D*)pgame())->polletSuggestion)
	{
		if (pgraphics->IsKindOf(RUNTIME_CLASS(cGraphicsOpenGL)))
		{
			//draw a translucent sphere to replace the circle
			cGraphicsOpenGL *opengl = (cGraphicsOpenGL *)pgraphics;
			opengl->enableLighting(FALSE);
			GLfloat materialAmbDiff[4]={ 1.0, 0.0, 0.0, 1.0 };
			::glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, materialAmbDiff );
			::glColor4f(1.0, 0, 0, 1.0);
			::glPushMatrix();
			::glTranslatef(position().x(), position().y(),position().z());
			::glEnable (GL_BLEND);
			::glBlendFunc (GL_SRC_ALPHA, GL_ONE);
			::glutSolidSphere(0.3f, 16, 16);
			::glDisable (GL_BLEND);
			::glPopMatrix();
		}
	}
	else
		cCritterArmed::draw(pgraphics, drawflags,pviewer4D);
}

void cCritterInvader4DPlayer::reset()
{
	cCritterArmedPlayer::reset();
	//Perhaps use setHealth to restore the health to a high value.
	setHealth(cGameInvader4D::PLAYERHEALTH);
}

BOOL cCritterInvader4DPlayer::collide(cCritter *pcritter)
{
	BOOL collideflag = cCritter::collide(pcritter);
	/* May sometimes do more stuff here if collideflag is TRUE.   */
	if (collideflag && pcritter->IsKindOf(RUNTIME_CLASS(cCritterInvader4DPropFrag)))
	{
		playSound("Ding");
		setHealth(health() + 1);
		pcritter->die();
	}
	return collideflag;
}

void cCritterInvader4DPlayer::update(CPopView *pactiveview)
{
	cCritterArmedPlayer::update(pactiveview);//Always call this first

#ifdef FOURDVIEWER
	this->lookAt(cVector::WAXIS);//0,0,0,1
	setAimVector(this->attitudeTangent()); //points to into innercube
#endif
}

int cCritterInvader4DPlayer::damage(int hitstrength)
{
	int damagereward = cCritter::damage(hitstrength); //Default bevavior.
	//Maybe change the sprite or something as well.
	return damagereward;
}

void cCritterInvader4DPlayer::roll(Real turnangle) //Rotate around _tangent
{
#ifdef FOURDVECTORS	
	cVector3 tempTangent(_tangent);
	cVector3 tempNormal(_normal);
	cVector3 tempBinormal(_binormal);
	
	cSpin rollturn(turnangle, tempTangent);
	tempBinormal.rotate(rollturn);
	tempNormal.rotate(rollturn);
		
	_tangent = tempTangent;
	_normal = tempNormal;
	_binormal = tempBinormal;
	
	_oldtangent = _tangent; //This signals fixNormalAndBinormal not to react to this.
	updateAttitude(0.0, TRUE); //Force the attitude to reflect this change if _attitudetomotionlock.
#else
	cCritter::roll(turnangle);
#endif
}

cCritterBullet* cCritterInvader4DPlayer::shoot()
{
	playSound("Gunshot");
	cCritterBullet *pbullet = cCritterArmed::shoot();
	// Find critter closest to your aiming line but ahead of you ("this").
	cCritter* paimprop = pgame()->pbiota()->pickClosestAhead(
		cLine(position(), aimvector()), this, PI/4.0,
		RUNTIME_CLASS(cCritterInvader4DProp), TRUE);
	/* Find prop critter closest to your aiming line but ahead of you ("this").  Only
	consider critters within a PI/4.0 cone aroudn the aiming line, and only
	consider critters of the class cCritter or (TRUE) its subclasses.  */
	cCritter* paimenemy = pgame()->pbiota()->pickClosestAhead(
		cLine(position(), aimvector()), this, PI/4.0,
		RUNTIME_CLASS(cCritterInvader4DRival), TRUE);
	/* Find enemy as well. */
	cCritter* paimtarget; /* Prefer shooting enemy. */
	if (paimenemy)
		paimtarget = paimenemy;
	else
		paimtarget = paimprop;
	if (paimtarget) //No point seeking a nonexistent target.
     	pbullet->addForce(new cForceObjectSeek(paimtarget, 10.0));
	return pbullet;
}

//====================cCritterInvader4DPlayerBullet==================
cCritterInvader4DPlayerBullet::cCritterInvader4DPlayerBullet()
{
	this->setSprite(new cSpriteHypercubeBullet());
	setRadius(5.0*cCritter::BULLETRADIUS); //Make bigger than usual.
	this->setSpeed(30.0);
}

void cCritterInvader4DPlayerBullet::update(CPopView *pview)
{
	cCritterBullet::update(pview);
	Real bound = 1.5;//0.9
	if(position().x()<bound&&
		position().x()>-bound&&
		position().y()<bound&&
		position().y()>-bound&&
		position().z()<bound&&
		position().z()>-bound)
	{	
		delete_me();
		return;
	}
}

//==================== cCritterInvader4DProp ====================
cCritterInvader4DProp::cCritterInvader4DProp(cGame *pownergame):
cCritter(pownergame)
{
	//Set the health and value. 
	_value = 10;
	// Make a sprite and use setSprite to install it.
	setPrismDz(2*cSprite::CRITTERPRISMDZ); //Make them thicker to look cooler.

	if (pgame()) //Just to be safe.
		setSprite(pgame()->randomSprite(pgame()->spritetype())); /* Let the game
			set the current default sprite. */
	psprite()->setEdged(FALSE);
	//Set a particular radius you like.
	setRadius(1.25);
	//Add some forces
	setMaxspeed(4.5); //Default is 3.0
	setAttitudeToMotionLock(FALSE); /* don't turn your sprite with the motions,
		instead let it tumble. */
	randomizeSpin(0.3, 1.5);//1 5

	//Use addForce to add forces.
	/* Default strngth is often 25.0, but we change it. The second arg is the
	_pulldirection to fall in, which is up the Z towards player who sits
	at high z looking down. */
	addForce(new cForceGravity(0.0, -cVector::WAXIS)); 
	
	if(pownergame->spritetype()==cGame::ST_HYPERCUBES||
		pownergame->spritetype()==cGame::ST_HYPERHOUSES||
		pownergame->spritetype()==cGame::ST_HYPERPYRAMIDS||
		pownergame->spritetype()==cGame::ST_HYPERTETRAHEDRONS)
	{	
		//randomizeVelcity() seems to distort 4D objects when
		//there are too many
		_velocity = cRandomizer::pinstance()->randomReal(0.1,50) * cVector3::randomUnitVector();//_velocity;
		synchSpeedAndDirectionToVelocity(); //This sets _speed and _tangent to match _velocity.
		fixNormalAndBinormal();
	}
	else
	{	
		randomizeVelocity(); //default range is MINSPEED to _maxspeed.
	}

	if(pownergame->spritetype()==cGame::ST_HYPERCUBES)
	{	
		setAttitudeToMotionLock(TRUE); //we want to use rotations in cSpriteHypercube
		setSprite(new cSpriteHypercube());
		setRadius(1.5);
	}
	else if(pownergame->spritetype()==cGame::ST_HYPERHOUSES)
	{	
		setAttitudeToMotionLock(TRUE); //we want to use rotations in cSpriteHypercube
		setSprite(new cSpriteHyperhouse());
		setRadius(1.5);
	}
	else if(pownergame->spritetype()==cGame::ST_HYPERPYRAMIDS)
	{	
		setAttitudeToMotionLock(TRUE); //we want to use rotations in cSpriteHypercube
		setSprite(new cSpriteHyperpyramid());
		setRadius(1.5);
	}
	else if(pownergame->spritetype()==cGame::ST_HYPERTETRAHEDRONS)
	{	
		setAttitudeToMotionLock(TRUE); //we want to use rotations in cSpriteHypercube
		setSprite(new cSpriteHypertetrahedron());
		setRadius(1.5);
	}
}

int cCritterInvader4DProp::damage(int hitstrength)
{
	int damagereward = cCritter::damage(hitstrength); //Default bevavior.
	//Maybe change the sprite or something as well.
	return damagereward;
}

BOOL cCritterInvader4DProp::collide(cCritter *pcritter)
{
	BOOL collideflag = cCritter::collide(pcritter);
	//May sometimes do more stuff here if collideflag is TRUE.
	return collideflag;
}

void cCritterInvader4DProp::update(CPopView *pactiveview)
{
	cCritter::update(pactiveview); //Always call this first
	if(_outcode)
	{	
		playSound("Bonk");
		pplayer()->damage(1); //punish the player
		delete_me(); //tell the game to remove yourself
		return;
	}
}

void cCritterInvader4DProp::die()
{
	playSound("Explosion");
	//Make some new tumbling fragment critters.
 	for (int i=0; i< cCritterInvader4DProp::FRAGCOUNT; i++)
		new cCritterInvader4DPropFrag(this);
	//Change the prop sprite
	_age = 0.0; //Use age for a time of the "dying act"
	setUseFixedLifetime(TRUE);
	setFixedLifetime(cCritterInvader4DProp::EXPLOSIONDISPLAYTIME);
	setShield(TRUE); //so you don't die again.
	setAttitudeToMotionLock(FALSE); /* In case this happened to be
			on, turn it off here so you're free to set the attitude as you like. */
	setSpin(0.0); //Stop tumbling
	setVelocity(cVector::ZEROVECTOR); //Stop moving
	setAcceleration(cVector::ZEROVECTOR);
	clearForcearray(); //Stop falling
#ifdef LOOPEXPLOSION
	Real oldradius = radius(); //Save radius because installing new sprite changes it.
	resetAttitude(); //So you're facing front for the "billboard" effect.
	cSpriteLoop *ploop = new cSpriteLoop();
	ploop->add(IDB_EXPLODE1);
	ploop->add(IDB_EXPLODE2);
	ploop->add(IDB_EXPLODE3);
	setSprite(ploop);
	ploop->setFlipwait(0.05); //How fast to flip the frames
	setRadius(oldradius/2.0); //Smaller explosion looks better.
#else //not LOOPEXPLOSION
	psprite()->setFilled(FALSE);
	psprite()->setEdged(TRUE);
	psprite()->setLineColor(psprite()->fillColor());
#endif //LOOPEXPLOSION
}		

//==================== cCritterInvader4DPropFrag ====================
cCritterInvader4DPropFrag::cCritterInvader4DPropFrag(cCritter *pcritterprop)
{
	if (pcritterprop->pgame())
		pcritterprop->pgame()->add(this); //Sets moveBox.
	setWrapflag(FALSE);
	setSprite(new cSpriteCircle()); //pgame()->randomSprite(cGame::ST_BUBBLES)); //SIMPLEPOLYGONS));
	psprite()->setEdged(FALSE);
	psprite()->setFillColor(pcritterprop->psprite()->fillColor());
	setRadius(pcritterprop->radius()/3.0);
	setMaxspeed(20.0); //Very fast
	randomizeVelocity(); //3D velocity
	setAttitudeToMotionLock(FALSE); //don't turn your sprite with the motions.
	randomizeSpin(1.0, 5.0);
	setShield(TRUE); // So you don't die again.
	//using lifetime of a bullet, we can define its own though.
	setUseFixedLifetime(TRUE);
	setFixedLifetime(cCritterInvader4DPropFrag::FIXEDLIFETIME);
	moveTo(pcritterprop->position()); // + tangent() * pcritterprop->radius());
	addForce(new cForceDrag(0.1)); //Default is 0.5
	addForce(new cForceGravity(100.0, 0.05*cVector::WAXIS));
}		

int cCritterInvader4DPropFrag::collidesWith(cCritter *pcritterother)
{
	if (pcritterother == pplayer())
		return cCollider::COLLIDEASARG; //so Player can eat them.
	else //to keep the speed up, don't do other collisions.
		return cCollider::DONTCOLLIDE;
}

void cCritterInvader4DPropFrag::update(CPopView *pactiveview)
{
	cCritter::update(pactiveview); //Always call this first
	if (_outcode & BOX_HIZ) /* use bitwise AND to check if a flag is set. */
	{
		cCritter::die(); //tell the game to remove yourself
		return;
	}
}

//==================== cCritterInvader4DRival ====================
cCritterInvader4DRival::cCritterInvader4DRival(cGame *pownergame):
cCritterArmedRobot(pownergame)
{
	//Set the health and value. 
	_value = 20;
	// Make a sprite and use setSprite to install it.
	if (pgame())
		setSprite(pgame()->randomSprite(cGame::ST_BITMAPS)); 
	//Choose randomly among available bitmaps
	//	setSprite(new cSpriteIcon(IDB_FACE)); //Or you could use a specific bitmap.
	//Always set target for cCritterArmedRobot
	setTarget(pplayer()); //Makes it automatically aim at pplayer.
	//Set the bullet
 	setBulletClass(RUNTIME_CLASS(cCritterInvader4DRivalBullet));
	//Set wait time between shots
	setWaitShoot(10.0); //Seconds between shots fired.
	setGunlength(1.0);
	//OR Erase the ugly gun line from these
	//setGunlength(0.0);
	// COMMENT NEXT LINE OUT TO TURN SHOOTING ON.
	//setArmed(FALSE); //TURN OFF THE SHOOTING.
	randomize(cSprite::MF_RADIUS);// Randomize size if you like.
	//Add some forces
	addForce(new cForceClassEvade(20.0, 4.0, 
		RUNTIME_CLASS(cCritterInvader4DPlayerBullet)));
	randomize(cCritter::MF_POSITION);
	randomize(cCritter::MF_VELOCITY); //Randomize velocity
}

int cCritterInvader4DRival::damage(int hitstrength)
{
	int damagereward = cCritter::damage(hitstrength); //Default bevavior.
	//Maybe change the sprite or something as well.
	return damagereward;
}	

BOOL cCritterInvader4DRival::collide(cCritter *pcritter)
{
	BOOL collideflag = cCritter::collide(pcritter);
	//May sometimes do more stuff here if collideflag is TRUE.
	return collideflag;
}

void cCritterInvader4DRival::update(CPopView *pactiveview)
{
	cCritterArmedRobot::update(pactiveview);//Always call this first
}

//====================cCritterInvader4DRivalBullet==================
cCritterInvader4DRivalBullet::cCritterInvader4DRivalBullet()
{
		//Maybe use bubbles for fun.
//	setSprite(new cSpriteBubblePie());
//	randomize(cPolygon::MF_COLOR); //randomize color of sprite.
//	_dieatedges = FALSE; //Include this in case you want the bullet to wrap around
}

void cCritterInvader4DRivalBullet::initialize(cCritterArmed *pshooter)
{
	cCritterBullet::initialize(pshooter);
	addForce( new cForceObjectSeek(ptarget(), 20.0)); 
		// Param is chaseacceleration.  Maybe should make this raw number a static.
	setRadius(0.5 * pshooter->radius());
		 //Make bullet size depend on shooter, but don't have to do this.
}

