#include "stdafx.h"
#include "graphicsopengl.h"
#include "hyperhouse.h"
#include "game.h" //Gives include biota.h, critter.h, sprite.h

IMPLEMENT_SERIAL(cSpriteHyperhouse, cSprite, 0 );
//================cSpriteHyperhouse========================
cSpriteHyperhouse::cSpriteHyperhouse()
{
	numOfVertices = 17;
	dimension = 4;
	drawnradius = 1.25;//_radius;
	vertices = new double * [dimension];//rows 4
	tmpMatrix = new double * [dimension];
	for(int i=0;i<dimension;i++)
	{	
		vertices[i] = new double[numOfVertices]; //init row by row
		tmpMatrix[i] = new double[numOfVertices]; //init row by row
	}
	
	initializeVertices(drawnradius);

	rotationMatrix = new double * [dimension];//rows 4
	for(i=0;i<dimension;i++)
		rotationMatrix[i] = new double[dimension]; //init row by row
	
	translationMatrix = new double [dimension];

	vertex1 = new cVector4();vertex2 = new cVector4();
	vertex3 = new cVector4(); vertex4 = new cVector4();
	vertex5 = new cVector4(); vertex6 = new cVector4();
	vertex7 = new cVector4(); vertex8 = new cVector4();
	vertex9 = new cVector4(); vertex10 = new cVector4();
	vertex11 = new cVector4(); vertex12 = new cVector4();
	vertex13 = new cVector4(); vertex14 = new cVector4();
	vertex15 = new cVector4(); vertex16 = new cVector4();
	vertex17 = new cVector4();
	
	spinSpeed = 0;
	sinkValue = 0.0;
}

cSpriteHyperhouse::~cSpriteHyperhouse()
{

	for(int i=0;i<dimension;i++)
	{
		delete [] (vertices[i]);
		vertices[i]=NULL;

		delete [] (rotationMatrix[i]);
		rotationMatrix[i]=NULL;

		delete [] (tmpMatrix[i]);
		tmpMatrix[i] = NULL;

	}
	delete [] vertices;
	vertices = NULL;

	delete [] tmpMatrix;
	tmpMatrix = NULL;

	delete [] rotationMatrix;
	rotationMatrix = NULL;

	delete translationMatrix;
	translationMatrix = NULL;

	delete vertex1;delete vertex2;delete vertex3;delete vertex4;
	delete vertex5;delete vertex6;delete vertex7;delete vertex8;
	delete vertex9;delete vertex10;delete vertex11;delete vertex12;
	delete vertex13;delete vertex14;delete vertex15;delete vertex16;
	vertex1 = NULL; vertex2 = NULL; vertex3 = NULL; vertex4 = NULL;
	vertex5 = NULL; vertex6 = NULL; vertex7 = NULL; vertex8 = NULL;
	vertex9 = NULL; vertex10 = NULL; vertex11 = NULL; vertex12 = NULL;
	vertex13 = NULL; vertex14 = NULL; vertex15 = NULL; vertex16 = NULL;
	
	delete vertex17;
	vertex17 = NULL;
}

void cSpriteHyperhouse::animate(Real dt, const cVector &critterdirection)
{
	spinSpeed = cRandomizer::pinstance()->randomReal(dt*0.5, dt*2);
	Real angle1 = this->spinSpeed;
	Real angle2 = this->spinSpeed;
	Real angle3 = this->spinSpeed;
	Real angle4 = this->spinSpeed;
	Real angle5 = this->spinSpeed;
	Real angle6 = this->spinSpeed;
	
	_spriteattitude = _spriteattitude* 
		cMatrix4::zRotation(angle4)*
		cMatrix4::yRotation(angle5)*
		cMatrix4::p14Rotation(angle1)*
		cMatrix4::xRotation(angle6)*
		cMatrix4::p24Rotation(angle2)*
		cMatrix4::p34Rotation(angle3);
			
	//extract info on rotation from _attitude and put it
	//in rotationMatrix(4 by 4)
	for(int i=0;i<dimension;i++)
	{
		cVector4 column = _spriteattitude.column(i);
		rotationMatrix[0][i] = column.x();
		rotationMatrix[1][i] = column.y();
		rotationMatrix[2][i] = column.z();
		rotationMatrix[3][i] = column.w();
	}

	//extract info on translation from _attitide and put it
	//in translationMatrix(4 by 1)
	cVector4 column = _spriteattitude.lastColumn();//.column(dimension);
	translationMatrix[0] = column.x();
	translationMatrix[1] = column.y();
	translationMatrix[2] = column.z();
	translationMatrix[3] = column.w();
	
	/*3
		rotationMatrix(4 by 4) times 
		vertices(4 by 16) is another 4 by 16 matrix tmpMatrix
	*/
	for (i=0; i<dimension; i++)
		for (int j=0; j<numOfVertices; j++)
		{
			tmpMatrix[i][j] = 0.0;
			for (int k=0; k<dimension; k++)
			{	
				tmpMatrix[i][j] += rotationMatrix[i][k]*vertices[k][j];
			}
		}
	
	/*3.5
	update tmpMatrix with a 4 by 1 translation matrix
	*/
	for (i=0; i<dimension; i++)
		for (int j=0; j<numOfVertices; j++)
		{
			tmpMatrix[i][j] = translationMatrix[i]+tmpMatrix[i][j];
		}
}

void cSpriteHyperhouse::draw(cGraphics *pgraphics, int drawflags, cCritterViewer4D * pviewer4D)
{
	BOOL drawfill = filled() && !(drawflags & CPopView::DF_WIREFRAME);
	
	//Outter cube
	setLineColor(cColorStyle::CN_BLUE);
	//front face / GREEN if filled
	vertex1->set(tmpMatrix[0][0],tmpMatrix[1][0], tmpMatrix[2][0], tmpMatrix[3][0]);//1st column
	vertex2->set(tmpMatrix[0][1],tmpMatrix[1][1], tmpMatrix[2][1], tmpMatrix[3][1]);//2nd column
	vertex3->set(tmpMatrix[0][2],tmpMatrix[1][2], tmpMatrix[2][2], tmpMatrix[3][2]);//3rd column
	vertex4->set(tmpMatrix[0][3],tmpMatrix[1][3], tmpMatrix[2][3], tmpMatrix[3][3]);//4th column
	
	if(!drawfill)
	{
		setLineColor(cColorStyle::CN_BLUE);
		pgraphics->drawline(*vertex1,*vertex2,_pcolorstyle);
		pgraphics->drawline(*vertex2,*vertex3,_pcolorstyle);
		pgraphics->drawline(*vertex3,*vertex4,_pcolorstyle);
		pgraphics->drawline(*vertex4,*vertex1,_pcolorstyle);
	}
	if(drawfill)
	{
		_pcolorstyle->setFillColor(cColorStyle::CN_GREEN);
		pgraphics->drawrectangle(*vertex1, *vertex2,*vertex3,*vertex4, _pcolorstyle);
	}
 	//back face / BLUE if filled
	vertex5->set(tmpMatrix[0][4],tmpMatrix[1][4], tmpMatrix[2][4], tmpMatrix[3][4]);//5th column
	vertex6->set(tmpMatrix[0][5],tmpMatrix[1][5], tmpMatrix[2][5], tmpMatrix[3][5]);//6th column
	vertex7->set(tmpMatrix[0][6],tmpMatrix[1][6], tmpMatrix[2][6], tmpMatrix[3][6]);//7th column
	vertex8->set(tmpMatrix[0][7],tmpMatrix[1][7], tmpMatrix[2][7], tmpMatrix[3][7]);//8th column
	
	if(!drawfill)
	{
		setLineColor(cColorStyle::CN_BLUE);
		pgraphics->drawline(*vertex5,*vertex6,_pcolorstyle);
		pgraphics->drawline(*vertex6,*vertex7,_pcolorstyle);
		pgraphics->drawline(*vertex7,*vertex8,_pcolorstyle);
		pgraphics->drawline(*vertex8,*vertex5,_pcolorstyle);
	}
	if(drawfill)
	{
		_pcolorstyle->setFillColor(cColorStyle::CN_BLUE);
		pgraphics->drawrectangle(*vertex5, *vertex6,*vertex7,*vertex8, _pcolorstyle);
	}
	//4 edges conncecting 2 faces / 4 faces connecting front and back
	if(!drawfill)
	{	
		setLineColor(cColorStyle::CN_BLUE);
		pgraphics->drawline(*vertex1,*vertex5,_pcolorstyle);
		pgraphics->drawline(*vertex2,*vertex6,_pcolorstyle);
		pgraphics->drawline(*vertex3,*vertex7,_pcolorstyle);
		pgraphics->drawline(*vertex4,*vertex8,_pcolorstyle);
	}
	if(drawfill)
	{
		//Face 1, black
		_pcolorstyle->setFillColor(cColorStyle::CN_BLACK);
		pgraphics->drawrectangle(*vertex1, *vertex4, *vertex8, *vertex5, _pcolorstyle);
		//Face 2, white
		_pcolorstyle->setFillColor(cColorStyle::CN_WHITE);
		pgraphics->drawrectangle(*vertex2, *vertex6, *vertex7, *vertex3, _pcolorstyle);
		//Face 3, red
		_pcolorstyle->setFillColor(cColorStyle::CN_RED);
		pgraphics->drawrectangle(*vertex1, *vertex2, *vertex6, *vertex5, _pcolorstyle);
		//face 4, orange
		_pcolorstyle->setFillColor(cColorStyle::CN_ORANGE);
		pgraphics->drawrectangle(*vertex3, *vertex4, *vertex8, *vertex7, _pcolorstyle);
	}
	
	//Inner cube
	//front face / BROWN if filled
	vertex9->set(tmpMatrix[0][8],tmpMatrix[1][8], tmpMatrix[2][8], tmpMatrix[3][8]);
	vertex10->set(tmpMatrix[0][9],tmpMatrix[1][9], tmpMatrix[2][9], tmpMatrix[3][9]);
	vertex11->set(tmpMatrix[0][10],tmpMatrix[1][10], tmpMatrix[2][10], tmpMatrix[3][10]);
	vertex12->set(tmpMatrix[0][11],tmpMatrix[1][11], tmpMatrix[2][11], tmpMatrix[3][11]);
	if(!drawfill)
	{
		setLineColor(cColorStyle::CN_RED);
		pgraphics->drawline(*vertex9,*vertex10,_pcolorstyle);
		pgraphics->drawline(*vertex10,*vertex11,_pcolorstyle);
		pgraphics->drawline(*vertex11,*vertex12,_pcolorstyle);
		pgraphics->drawline(*vertex12,*vertex9,_pcolorstyle);
	}
	if(drawfill)
	{
		_pcolorstyle->setFillColor(cColorStyle::CN_BROWN);
		pgraphics->drawrectangle(*vertex9, *vertex10,*vertex11,*vertex12, _pcolorstyle);
	}
	//back face / PURPLE if filled
	vertex13->set(tmpMatrix[0][12],tmpMatrix[1][12], tmpMatrix[2][12], tmpMatrix[3][12]);
	vertex14->set(tmpMatrix[0][13],tmpMatrix[1][13], tmpMatrix[2][13], tmpMatrix[3][13]);
	vertex15->set(tmpMatrix[0][14],tmpMatrix[1][14], tmpMatrix[2][14], tmpMatrix[3][14]);
	vertex16->set(tmpMatrix[0][15],tmpMatrix[1][15], tmpMatrix[2][15], tmpMatrix[3][15]);
	if(!drawfill)
	{
		setLineColor(cColorStyle::CN_RED);
		pgraphics->drawline(*vertex13,*vertex14,_pcolorstyle);
		pgraphics->drawline(*vertex14,*vertex15,_pcolorstyle);
		pgraphics->drawline(*vertex15,*vertex16,_pcolorstyle);
		pgraphics->drawline(*vertex16,*vertex13,_pcolorstyle);
	}
	if(drawfill)
	{
		_pcolorstyle->setFillColor(cColorStyle::CN_PURPLE);
		pgraphics->drawrectangle(*vertex13, *vertex14,*vertex15,*vertex16, _pcolorstyle);
	}
	//4 edges connecting 2 faces / 4 faces connecting front and back
	if(!drawfill)
	{
		setLineColor(cColorStyle::CN_RED);
		pgraphics->drawline(*vertex9,*vertex13,_pcolorstyle);
		pgraphics->drawline(*vertex10,*vertex14,_pcolorstyle);
		pgraphics->drawline(*vertex11,*vertex15,_pcolorstyle);
		pgraphics->drawline(*vertex12,*vertex16,_pcolorstyle);
	}
	if(drawfill)
	{	
		//Face 1, yellow
		_pcolorstyle->setFillColor(cColorStyle::CN_YELLOW);
		pgraphics->drawrectangle(*vertex9, *vertex13, *vertex16, *vertex12, _pcolorstyle);
		//Face 2, light blue
		_pcolorstyle->setFillColor(cColorStyle::CN_LIGHTBLUE);
		pgraphics->drawrectangle(*vertex10, *vertex14, *vertex15, *vertex11, _pcolorstyle);
		//Face 3, light gray
		_pcolorstyle->setFillColor(cColorStyle::CN_LIGHTGRAY);
		pgraphics->drawrectangle(*vertex9, *vertex10, *vertex14, *vertex13, _pcolorstyle);
		//Face 4, light red
		_pcolorstyle->setFillColor(cColorStyle::CN_LIGHTRED);
		pgraphics->drawrectangle(*vertex12, *vertex11, *vertex15, *vertex16, _pcolorstyle);
	}

	//8 edges connecting 2 cubes / 10 faces
	if(!drawfill)
	{
		setLineColor(cColorStyle::CN_PURPLE);
		pgraphics->drawline(*vertex1,*vertex9,_pcolorstyle);
		pgraphics->drawline(*vertex2,*vertex10,_pcolorstyle);
		pgraphics->drawline(*vertex3,*vertex11,_pcolorstyle);
		pgraphics->drawline(*vertex4,*vertex12,_pcolorstyle);
		pgraphics->drawline(*vertex5,*vertex13,_pcolorstyle);
		pgraphics->drawline(*vertex6,*vertex14,_pcolorstyle);
		pgraphics->drawline(*vertex7,*vertex15,_pcolorstyle);
		pgraphics->drawline(*vertex8,*vertex16,_pcolorstyle);
	}
	if(drawfill)
	{
		//4 Faces 
		//dark red
		_pcolorstyle->setFillColor(RGB(190,0,0));
		pgraphics->drawrectangle(*vertex1,*vertex9, *vertex12, *vertex4,_pcolorstyle);
		//dark green
		_pcolorstyle->setFillColor(RGB(0,190,0));
		pgraphics->drawrectangle(*vertex1,*vertex9, *vertex10, *vertex2,_pcolorstyle);
		//dark blue
		_pcolorstyle->setFillColor(RGB(0,0,190));
		pgraphics->drawrectangle(*vertex2,*vertex10, *vertex11, *vertex3,_pcolorstyle);
		//dark yellow
		_pcolorstyle->setFillColor(RGB(190,190,0));
		pgraphics->drawrectangle(*vertex4,*vertex12, *vertex11, *vertex3,_pcolorstyle);
		
		//4 Faces
		//dark magenta
		_pcolorstyle->setFillColor(RGB(190,0,190));
		pgraphics->drawrectangle(*vertex5,*vertex13, *vertex16, *vertex8,_pcolorstyle);
		//dark cyan
		_pcolorstyle->setFillColor(RGB(0,190,190));
		pgraphics->drawrectangle(*vertex5,*vertex13, *vertex14, *vertex6,_pcolorstyle);
		//money green
		_pcolorstyle->setFillColor(RGB(190,220,200));
		pgraphics->drawrectangle(*vertex6,*vertex14, *vertex15, *vertex7,_pcolorstyle);
		//sky blue
		_pcolorstyle->setFillColor(RGB(170,220,250));
		pgraphics->drawrectangle(*vertex8,*vertex16, *vertex15, *vertex7,_pcolorstyle);
		
		//2 Faces
		//cream
		_pcolorstyle->setFillColor(RGB(255,251,240));
		pgraphics->drawrectangle(*vertex2,*vertex10, *vertex14, *vertex6,_pcolorstyle);
		//intermediate gray
		_pcolorstyle->setFillColor(RGB(160,160,164));
		pgraphics->drawrectangle(*vertex3,*vertex11, *vertex15, *vertex7,_pcolorstyle);
		
		//2 Faces
		//medium gray
		_pcolorstyle->setFillColor(RGB(128,128,128));
		pgraphics->drawrectangle(*vertex1,*vertex9, *vertex13, *vertex5,_pcolorstyle);
		//magenta
		_pcolorstyle->setFillColor(RGB(255,0,255));
		pgraphics->drawrectangle(*vertex4,*vertex12, *vertex16, *vertex8,_pcolorstyle);
	}

	vertex17->set(tmpMatrix[0][16],tmpMatrix[1][16], tmpMatrix[2][16], tmpMatrix[3][16]);//17th column 
	setLineColor(cColorStyle::CN_YELLOW);
	if(!drawfill)
	{	
	//	_pcolorstyle->setLineColor(cColorStyle::CN_PURPLE);
		_pcolorstyle->setLineColor(RGB(0,230,150));
		pgraphics->drawline(*vertex17,*vertex1,_pcolorstyle);
		pgraphics->drawline(*vertex17,*vertex2,_pcolorstyle);
		pgraphics->drawline(*vertex17,*vertex5,_pcolorstyle);
		pgraphics->drawline(*vertex17,*vertex6,_pcolorstyle);
		
		
		_pcolorstyle->setLineColor(RGB(0,180,100));
		pgraphics->drawline(*vertex17,*vertex3,_pcolorstyle);
		pgraphics->drawline(*vertex17,*vertex4,_pcolorstyle);
		pgraphics->drawline(*vertex17,*vertex7,_pcolorstyle);
		pgraphics->drawline(*vertex17,*vertex8,_pcolorstyle);
	}
	if(drawfill)//to be changed later to 8 faces
	{	
		//Roof color
		_pcolorstyle->setFillColor(RGB(0,230,150));
		
		pgraphics->drawtriangle(*vertex17, *vertex1,*vertex2, _pcolorstyle);
		pgraphics->drawtriangle(*vertex17, *vertex2,*vertex6, _pcolorstyle);
		pgraphics->drawtriangle(*vertex17, *vertex5,*vertex6, _pcolorstyle);
		pgraphics->drawtriangle(*vertex17, *vertex1,*vertex5, _pcolorstyle);

		
//		_pcolorstyle->setFillColor(RGB(0,180,100));
		pgraphics->drawtriangle(*vertex17, *vertex4,*vertex3, _pcolorstyle);
		pgraphics->drawtriangle(*vertex17, *vertex3,*vertex7, _pcolorstyle);
		pgraphics->drawtriangle(*vertex17, *vertex8,*vertex7, _pcolorstyle);
		pgraphics->drawtriangle(*vertex17, *vertex4,*vertex8, _pcolorstyle);

		//fill up gaps in between
		pgraphics->drawtriangle(*vertex17, *vertex1,*vertex3, _pcolorstyle);
		pgraphics->drawtriangle(*vertex17, *vertex2,*vertex4, _pcolorstyle);
		pgraphics->drawtriangle(*vertex17, *vertex5,*vertex7, _pcolorstyle);
		pgraphics->drawtriangle(*vertex17, *vertex6,*vertex8, _pcolorstyle);

	}
}

void cSpriteHyperhouse::setRadius(Real radius)
{
	cSprite::setRadius(radius);
	
	//The actual critter's size is about 2/3 of a 
	//sprite hypercube.  To increase hit probability
	//we reduce the actual radius
	drawnradius = radius*0.5;
	initializeVertices(drawnradius);	
}

void cSpriteHyperhouse::initializeVertices(Real radius)
{
	sinkValue = 0.3;
	//front face
	//vertex 1
	vertices[0][0] = radius;
	vertices[1][0] = radius;
	vertices[2][0] = radius;
	vertices[3][0] = radius-sinkValue;
	//vertex 2
	vertices[0][1] = radius;
	vertices[1][1] = -radius;
	vertices[2][1] = radius;
	vertices[3][1] = radius-sinkValue;
	//vertex 3
	vertices[0][2] = -radius;
	vertices[1][2] = -radius;
	vertices[2][2] = radius;
	vertices[3][2] = radius-sinkValue;
	//vertex 4
	vertices[0][3] = -radius;
	vertices[1][3] = radius;
	vertices[2][3] = radius;
	vertices[3][3] = radius-sinkValue;
	//back face
	//vertex 5
	vertices[0][4] = radius;
	vertices[1][4] = radius;
	vertices[2][4] = -radius;
	vertices[3][4] = radius-sinkValue;
	//vertex 6
	vertices[0][5] = radius;
	vertices[1][5] = -radius;
	vertices[2][5] = -radius;
	vertices[3][5] = radius-sinkValue;
	//vertex 7
	vertices[0][6] = -radius;
	vertices[1][6] = -radius;
	vertices[2][6] = -radius;
	vertices[3][6] = radius-sinkValue;
	//vertex 8
	vertices[0][7] = -radius;
	vertices[1][7] = radius;
	vertices[2][7] = -radius;
	vertices[3][7] = radius-sinkValue;

	//Inner cube
	//front face
	//vertex 9
	vertices[0][8] = radius;
	vertices[1][8] = radius;
	vertices[2][8] = radius;
	vertices[3][8] = -radius-sinkValue;
	//vertex 10
	vertices[0][9] = radius;
	vertices[1][9] = -radius;
	vertices[2][9] = radius;
	vertices[3][9] = -radius-sinkValue;
	//vertex 11
	vertices[0][10] = -radius;
	vertices[1][10] = -radius;
	vertices[2][10] = radius;
	vertices[3][10] = -radius-sinkValue;
	//vertex 12
	vertices[0][11] = -radius;
	vertices[1][11] = radius;
	vertices[2][11] = radius;
	vertices[3][11] = -radius-sinkValue;
	//back face
	//vertex 13
	vertices[0][12] = radius;
	vertices[1][12] = radius;
	vertices[2][12] = -radius;
	vertices[3][12] = -radius-sinkValue;
	//vertex 14
	vertices[0][13] = radius;
	vertices[1][13] = -radius;
	vertices[2][13] = -radius;
	vertices[3][13] = -radius-sinkValue;
	//vertex 15
	vertices[0][14] = -radius;
	vertices[1][14] = -radius;
	vertices[2][14] = -radius;
	vertices[3][14] = -radius-sinkValue;
	//vertex 16
	vertices[0][15] = -radius;
	vertices[1][15] = radius;
	vertices[2][15] = -radius;
	vertices[3][15] = -radius-sinkValue;
	
	//vertex 17
	vertices[0][16] = 0;//radius;
	vertices[1][16] = 0;//radius;
	vertices[2][16] = 0;//radius;
	vertices[3][16] = radius*3-sinkValue;

}
