#ifndef HYPERHOUSE_H
#define HYPERHOUSE_H

////////////cSpriteHyperhouse///////////////////
class cSpriteHyperhouse : public cSprite
{
DECLARE_SERIAL(cSpriteHyperhouse); 
public:
	cSpriteHyperhouse();//Default constructor of _childspriteptr will be a zero-size array.
	virtual ~cSpriteHyperhouse();
//	void Serialize(CArchive &ar);

	virtual void draw(cGraphics *pgraphics, int drawflags = 0, cCritterViewer4D * pviewer4D=NULL); /* Default is to cascade
//		calls to the _childspriteptr members. */
	virtual void animate(Real dt, const cVector &critterdirection); // Default is to cascade.
	virtual void setRadius(Real radius);
protected:
	void initializeVertices(Real radius);

protected:
	double ** vertices; //4 x 17 matrix storing coords of 16 vertices
	int numOfVertices; //17
	int dimension; //4 in our case
	double drawnradius;
	double ** rotationMatrix; //4 x 4 matrix for 4D rotations
	double * translationMatrix;//4 x 1 matrix for 4D translation
	double **tmpMatrix; //4 x 17 matrix, product of rotationMatrix and vertices

	cVector4 * vertex1;cVector4 * vertex2;cVector4 * vertex3;cVector4 * vertex4;
	cVector4 * vertex5;cVector4 * vertex6;cVector4 * vertex7;cVector4 * vertex8;
	cVector4 * vertex9;cVector4 * vertex10;cVector4 * vertex11;cVector4 * vertex12;
	cVector4 * vertex13;cVector4 * vertex14;cVector4 * vertex15;cVector4 * vertex16;
	cVector4 * vertex17;

	Real spinSpeed;
	Real sinkValue;
};

#endif