#ifndef HYPERPYRAMID_H
#define HYPERPYRAMID_H

#include "sprite.h"
////////////cSpriteHyperpyramid///////////////////
class cSpriteHyperpyramid : public cSprite
{
DECLARE_SERIAL(cSpriteHyperpyramid); 
public:
	cSpriteHyperpyramid(); //Default constructor of _childspriteptr will be a zero-size array.
	virtual ~cSpriteHyperpyramid();
//	void Serialize(CArchive &ar);

	virtual void draw(cGraphics *pgraphics, int drawflags = 0, cCritterViewer4D * pviewer4D=NULL); /* Default is to cascade
//		calls to the _childspriteptr members. */
	virtual void animate(Real dt, const cVector &critterdirection); // Default is to cascade.
	virtual void setRadius(Real radius);
protected:
	void initializeVertices(Real radius);

protected:
	double ** vertices; //4 x 9 matrix storing coords of 16 vertices
	int numOfVertices; //9
	int dimension; //4 in our case
	double drawnradius;
	double ** rotationMatrix; //4 x 4 matrix for 4D rotations
	double * translationMatrix;//4 x 1 matrix for 4D translation
	double **tmpMatrix; //4 x 9 matrix, product of rotationMatrix and vertices

	cVector4 * vertex1;cVector4 * vertex2;cVector4 * vertex3;cVector4 * vertex4;
	cVector4 * vertex5;cVector4 * vertex6;cVector4 * vertex7;cVector4 * vertex8;
	cVector4 * vertex9;

	Real spinSpeed;
	Real sinkValue;
};

#endif