#include "stdafx.h"
#include "listener4D.h"
#include "game.h" //Gives include biota.h, critter.h, sprite.h

IMPLEMENT_SERIAL(cListenerArrowAttitude4D, cListener, 0 );
//=================cListenerArrowAttitude4D Code===================================================
void cListenerArrowAttitude4D::listen(Real dt, cCritter *pcritter) /* used in Invader4D */
{
	cController *pcontroller = pcritter->pgame()->pcontroller();
	/* Note that since I set the velocity to 0.0 when I'm not
		pressing an arrow key, this means that acceraltion forces don't get
		to have accumulating effects on a critter with a cListenerScooter listener. So rather
		than having some very half-way kinds of acceleration effects, I go aheand and
		set acceleration to 0.0 in here. */
	pcritter->setAcceleration(cVector::ZEROVECTOR);	

	if (!pcontroller->keyonplain(VK_LEFT) &&
		!pcontroller->keyonplain(VK_RIGHT) &&
		!pcontroller->keyonplain(VK_DOWN) &&
		!pcontroller->keyonplain(VK_UP) &&
		!pcontroller->keyonplain(VK_PAGEDOWN) &&
		!pcontroller->keyonplain(VK_PAGEUP) &&
		!pcontroller->keyonplain(VK_HOME) &&
		!pcontroller->keyonplain(VK_END) 
		)
	{
		pcritter->setVelocity(cVector::ZEROVECTOR);
		return;
	}
	
	pcritter->copyAttitudeMatrixToMotionMatrix(); //Changes _velocity
	
	/* If you get here, you've pressed an arrow key.  First match the velocity to 
			the arrow key direction, and then match the attitude. */
	if((pcontroller->keyonplain(VK_LEFT)||
		pcontroller->keyonplain(VK_RIGHT))&&
		(pcontroller->keyonplain(VK_END)||
		pcontroller->keyonplain(VK_HOME))
		)
	{
		pcritter->setVelocity(cVector::ZEROVECTOR);
		return;
	}
	if((pcontroller->keyonplain(VK_UP)||
		pcontroller->keyonplain(VK_DOWN))&&
		(pcontroller->keyonplain(VK_END)||
		pcontroller->keyonplain(VK_HOME))
		)
	{
		pcritter->setVelocity(cVector::ZEROVECTOR);
		return;
	}	
	if (pcontroller->keyonplain(VK_LEFT))
		pcritter->setVelocity(pcritter->maxspeed() * pcritter->attitudeNormal());
	if (pcontroller->keyonplain(VK_RIGHT))
		pcritter->setVelocity(-pcritter->maxspeed() * pcritter->attitudeNormal());
	if (pcontroller->keyonplain(VK_PAGEDOWN))
		pcritter->setVelocity(-pcritter->maxspeed() * pcritter->attitudeTangent());
	if (pcontroller->keyonplain(VK_PAGEUP))
		pcritter->setVelocity(pcritter->maxspeed() * pcritter->attitudeTangent());
	if (pcontroller->keyonplain(VK_DOWN) && pcritter->in3DWorld())
		pcritter->setVelocity(-pcritter->maxspeed() * pcritter->attitudeBinormal());
	if (pcontroller->keyonplain(VK_UP)&& pcritter->in3DWorld())
		pcritter->setVelocity(pcritter->maxspeed() * pcritter->attitudeBinormal());
	if (pcontroller->keyonplain(VK_HOME)&&pcritter->in3DWorld())
	{	
		pcritter->roll(-dt*turnspeed(pcontroller->keystateage(VK_HOME)));
		pcritter->copyMotionMatrixToAttitudeMatrix();
	}
	if (pcontroller->keyonplain(VK_END)&&pcritter->in3DWorld())
	{	
		pcritter->roll(dt*turnspeed(pcontroller->keystateage(VK_END)));
		pcritter->copyMotionMatrixToAttitudeMatrix();
	}
}
