// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MainFrm.h"
#include "Pop.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DONTOUTSTRIPGRAPHICSREFRESHRATE
	/* If you comment in DONTOUTSTRIPGRAPHICSREFRESHRATE, we try and set the maximum
	update rate to not exceed the display's inherent refresh rate.*/

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_WINDOW_NEW, OnWindowNew)
	ON_WM_SIZE()
	ON_COMMAND(ID_WINDOW_AUTOTILE, OnWindowAutotile)
	ON_UPDATE_COMMAND_UI(ID_WINDOW_AUTOTILE, OnUpdateWindowAutotile)
	ON_COMMAND(ID_WINDOW_AUTOFOCUS, OnWindowAutofocus)
	ON_UPDATE_COMMAND_UI(ID_WINDOW_AUTOFOCUS, OnUpdateWindowAutofocus)
	ON_WM_CLOSE()
	ON_COMMAND(ID_HELP_USERSGUIDE, OnHelpUsersguide)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame():
_autotile(TRUE),	//RR
_autofocus(FALSE)  //Nice feature, but is confusing for new users.
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
#ifdef DONTOUTSTRIPGRAPHICSREFRESHRATE
	int refreshrate = ::GetDeviceCaps(GetDC()->GetSafeHdc(), VREFRESH);
	if (refreshrate > 1) /* Some systems won't give this info and just return 0 or 1.
		and for these, we'll just leave the default mindt that was set in CPopApp constructor. */
		((CPopApp*)::AfxGetApp())->
		_timer.setMinDt(1.0/double(refreshrate)); //Don't run faster than 100 updates a second.
#endif //DONTOUTSTRIPGRAPHICSREFRESHRATE
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.cx = CPopApp::STARTPIXELWIDTH; //800;
	cs.cy = CPopApp::STARTPIXELHEIGHT; //600;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnWindowNew() 
{
	if (getMDIChildCount() >= CPopApp::MAXCHILDWINDOWCOUNT)
	{
		::MessageBeep(MB_ICONEXCLAMATION);
		return;
	}
	CMDIFrameWnd::OnWindowNew(); //Call base class handler.
	//My code.  RR.
		/* Keep tiling so the view windows stay "stuck" to the outer window.
			 The CMainFrame::getMDIChildCount() is a helper function I added.
			Gets the number of existing child frames, including this one.  If
			there are more than one child, then I tile, otherwise I don't tile
			because whenever I have only one child, it is maximized.  You don't
			want to tile when a single window is maximized as this brings its 
			caption bar back down into the MDI client area.*/
	if (_autotile && getMDIChildCount() > 1) //Automatically keep all views tiled
		MDITile(MDITILE_VERTICAL);
}

void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CMDIFrameWnd::OnSize(nType, cx, cy); //Call base class handler.
	//My code.  RR.
	if (_autotile && getMDIChildCount() > 1) //Automatically keep all views tiled
		MDITile(MDITILE_VERTICAL);
}

void CMainFrame::OnWindowAutotile() //RR
{
	_autotile ^= TRUE;
	if (_autotile && getMDIChildCount() > 1) //Automatically keep all views tiled
		MDITile(MDITILE_VERTICAL);
	if (_autotile) //Retile now if necessary, or maximize if there's only one.
	{	//See the comments on this code in CMainFrame::OnWindowNew  above.
		int viewcount = getMDIChildCount(); 
		if (viewcount > 1) 
			MDITile(MDITILE_VERTICAL);
		else if (viewcount == 1) //There's only one split view, so maximize it
		{
			CMDIChildWnd *childframe = MDIGetActive();
			childframe->ShowWindow(SW_SHOWMAXIMIZED); 
		}
	}
}

void CMainFrame::OnUpdateWindowAutotile(CCmdUI* pCmdUI) //RR
{
	pCmdUI->SetCheck(_autotile?1:0);
}

void CMainFrame::OnWindowAutofocus() //RR
{
	_autofocus ^= TRUE;	
}

void CMainFrame::OnUpdateWindowAutofocus(CCmdUI* pCmdUI) //RR
{
	pCmdUI->SetCheck(_autofocus?1:0);
}

//Helper function

int CMainFrame::getMDIChildCount()
{
	int count = 0;
	CMDIChildWnd *next, *current = MDIGetActive();
	if (!current)
		return 0;
	while (TRUE) //We exit this endless loop with a return that's sure to happen.
	{
		count++;
		MDINext();
		next = MDIGetActive();
		if (next == current)
			return count;
	}
}

void CMainFrame::OnClose() 
{
	CMDIFrameWnd::OnClose();
}

void CMainFrame::OnHelpUsersguide() 
{
	::WinHelp(GetSafeHwnd(), "spaceinvaders4D.hlp", HELP_CONTENTS, 0);	
}

