#ifndef METRIC_H
#define METRIC_H

#include "critter.h"
//#define USEMETRIC
/* Comment in USEMETRIC to have methods like Real cBiota::distance(cCritter *pa, 
	cCritter *pb) do a lookup of the distance in the precomputed cMetricCritter 
	array.  You can look up the direction as well.  In USEMETRIC mode, the
	the cBiota::updateMetric() refreshes the cMetricCritter array with every
	cGame::step.  If you cmment out USEMETRIC you avoid the updateMetric overhead,
	but you have to compute each critter-to-critter distance and direction each
	time its requested.  For our current games, the code runs about equally fast
	with or without USEMETRIC.  But should we start forces or methods in which
	the critters repeatedly check their distances (such as for flocking behavior),
	it may be that USEMETRIC improves the speed.
	WARNING: USEMETRIC isn't fully debugged.*/


/* The MFC CMap hashtable turns out to be fairly slow.  It cuts speed in half for both
large and huge critter counts.  So I tried making my own metric class with arrays.
I haven't fully optimized it yet, but it still seems to cut speed by about 
25%, so generally I'm not going to use it. */

/* The cDistanceAndDirection utility class is needed for the values to be looked up
in the cMetricCritter.  This calss saves information about the distance and unit
vector direction between pairs of critters. */ 
class cDistanceAndDirection
{
public:
	Real _distance;
	cVector _direction;
	cDistanceAndDirection():_distance(0.0){} //Default cVector is (0,0).
	~cDistanceAndDirection(){}
	cDistanceAndDirection(Real dist, const cVector &dir){_distance = dist; _direction = dir;}
};

class cMetricCritter 
{
private:
	int _crittercount;
	int _arraysize; //Will always be _crittercount*_crittercount
	cDistanceAndDirection **_array;
	int _index(int i, int j){return j*_crittercount + i;}
public:
	void setSizeForCritterCount(int crittercount);
	cMetricCritter();
	~cMetricCritter();
	Real distance(cCritter *first, cCritter *second)
		{return	_array[first->metrickey()][second->metrickey()]._distance;}
	cVector direction(cCritter *first, cCritter *second)
		{return _array[first->metrickey()][second->metrickey()]._direction;}
	cDistanceAndDirection distanceanddirection(cCritter *first, cCritter *second)
		{return _array[first->metrickey()][second->metrickey()];}
	void setAt(int i, int j, Real distance, const cVector &direction)
		{_array[i][j]._distance = distance;	_array[i][j]._direction = direction;}
};

#endif //METRIC_H